#!/usr/bin/env perl
#
# This script Copyright (C) 2004 Craig B. Agricola (craig@theagricolas.org)
#
# canny.src can be grabbed from
# ftp://figment.csee.usf.edu/pub/Edge_Comparison/source_code/canny.src
#
# The credit goes to Mike Heath (heath@csee.usf.edu); I've only made a few
# trivial changes to make the program into a filter and added a Makefile to
# build it.
#
open(IN,"canny.src")||die "Couldn't open canny.src: $!";
close(OUT);
mkdir("canny_edge");
while(<IN>) {
  if (/^<-*\s*begin\s+([^-\s]+)\s*-*>$/){
	print"$1\n";$f=$1;
	open(OUT,">canny_edge/$f")||die "Couldn't write canny_edge/$f: $!";
  } elsif (/^<-*\s*end\s+$f\s*-*>$/){ close(OUT); }
  else { print OUT; }
}
open(OUT, ">canny_edge/Makefile");
print OUT <<'EOF_MAKEFILE';
CFLAGS=-O3
LDFLAGS=-lm
TARGET=canny_edge
SOURCE=canny_edge.c hysteresis.c pgm_io.c

$(TARGET): $(SOURCE)
clean:
	rm -f $(TARGET)
EOF_MAKEFILE
close(OUT);
open(PATCH, "|patch -p0");
print PATCH <<'EOF_PATCH';
--- canny_edge.orig/canny_edge.c
+++ canny_edge/canny_edge.c
@@ -83,8 +83,7 @@
 {
    char *infilename = NULL;  /* Name of the input image */
    char *dirfilename = NULL; /* Name of the output gradient direction image */
-   char outfilename[128];    /* Name of the output "edge" image */
-   char composedfname[128];  /* Name of the output "direction" image */
+   char *outfilename = NULL; /* Name of the output "edge" image */
    unsigned char *image;     /* The input image */
    unsigned char *edge;      /* The output edge image */
    int rows, cols;           /* The dimensions of the image. */
@@ -99,10 +98,8 @@
    /****************************************************************************
    * Get the command line arguments.
    ****************************************************************************/
-   if(argc < 5){
-   fprintf(stderr,"\n<USAGE> %s image sigma tlow thigh [writedirim]\n",argv[0]);
-      fprintf(stderr,"\n      image:      An image to process. Must be in ");
-      fprintf(stderr,"PGM format.\n");
+   if(argc < 4){
+   fprintf(stderr,"\n<USAGE> %s sigma tlow thigh [writedirim]\n",argv[0]);
       fprintf(stderr,"      sigma:      Standard deviation of the gaussian");
       fprintf(stderr," blur kernel.\n");
       fprintf(stderr,"      tlow:       Fraction (0.0-1.0) of the high ");
@@ -117,12 +114,11 @@
       exit(1);
    }
 
-   infilename = argv[1];
-   sigma = atof(argv[2]);
-   tlow = atof(argv[3]);
-   thigh = atof(argv[4]);
+   sigma = atof(argv[1]);
+   tlow = atof(argv[2]);
+   thigh = atof(argv[3]);
 
-   if(argc == 6) dirfilename = infilename;
+   if(argc == 5) dirfilename = argv[4];
    else dirfilename = NULL;
 
    /****************************************************************************
@@ -138,18 +134,11 @@
    * Perform the edge detection. All of the work takes place here.
    ****************************************************************************/
    if(VERBOSE) printf("Starting Canny edge detection.\n");
-   if(dirfilename != NULL){
-      sprintf(composedfname, "%s_s_%3.2f_l_%3.2f_h_%3.2f.fim", infilename,
-      sigma, tlow, thigh);
-      dirfilename = composedfname;
-   }
    canny(image, rows, cols, sigma, tlow, thigh, &edge, dirfilename);
 
    /****************************************************************************
    * Write out the edge image to a file.
    ****************************************************************************/
-   sprintf(outfilename, "%s_s_%3.2f_l_%3.2f_h_%3.2f.pgm", infilename,
-      sigma, tlow, thigh);
    if(VERBOSE) printf("Writing the edge iname in the file %s.\n", outfilename);
    if(write_pgm_image(outfilename, edge, rows, cols, "", 255) == 0){
       fprintf(stderr, "Error writing the edge image, %s.\n", outfilename);
EOF_PATCH
close(PATCH);
